#include "Animation.h"

Animation::Animation()
{
	currentFrame = 0;
	animationTimer.setMode(THIRTY_FRAMES);
	numLoops = -1;
	animationTimer.setLimit(1);
	animationTimer.storeTime();
	setX(0);
	setY(0);
}

Animation::~Animation()
{
	this->clear();
}

void Animation::update()
{
	animationTimer.update();
	if(animationTimer.getRemaining() < 0)
	{
		currentFrame++;
		animationTimer.setLimit(1);
	}
	if(currentFrame > this->size()-1)
	{
		if(numLoops == -1)
		{
			currentFrame = 0;
		}
		else if( numLoops > 0)
		{
		    currentFrame = 0;
		    numLoops--;
		}
		else
		{
			currentFrame = this->size()-1;
		}
	}
}

void Animation::render(SDL_Surface *screen)
{
	this->renderImage(currentFrame,screen,getX(),getY());
}


