#ifndef ANIMATION_H
#define ANIMATION_H

#include "Image.h"
#include "Timer.h"


class Animation : public Image
{
public:
	Animation();
	~Animation();

	void update();
	void render(SDL_Surface* screen);

	void setFrameRate(uint fps)
	{
		animationTimer.setMode(fps);
	}
	void setLooping(int numLoops)       //  If numLoops is set to minus 1 then this is the same as inf looping.
	{
	    this->numLoops = numLoops;
	}
	void setLooping(bool shouldLoop)
	{
		if(shouldLoop)
            numLoops = -1;
        else
            numLoops = 0;
	}
private:
	Timer animationTimer;
	//bool shouldLoop;
	int numLoops;
	uint currentFrame;
};
#endif	//	ANIMATION_H

