#ifndef BASESTATE_H_INCLUDED
#define BASESTATE_H_INCLUDED

#include <SDL/SDL.h>
#include "InputHandler.h"  // Keyboard handler
#include <vector>
#include "Types.h"
#include "Variable.h"

#ifndef STATE_NULL
	#define STATE_NULL 0	//	Exit the program
#endif	//	STATE_NULL

using namespace std;

class BaseState
{
   public:
      BaseState();
      virtual ~BaseState();

      //  These vitual functions will be overidden depending on use
      virtual void render(SDL_Surface *screen);
      virtual void update();
      virtual void keyboard();
      virtual void init();    // init function for states
		virtual void clear();	//	tidy up function

		uint getNextState()
		{
			return nextState;
		}
		void setNextState(uint next)
		{
			nextState = next;
			needInit = true;
		}
		bool getNeedInit()
		{
			return needInit;
		}
		void setNeedInit(bool init)
		{
			needInit = init;
		}
      bool getNullifyState()
      {
         return nullify;
      }

		void nullifyState()
      {
         nullify = true;
			nextState = STATE_NULL;
      }

		//	This is used to pass variables between states!
		vector<Variable> variables;
   protected:

      InputHandler input;
      bool nullify;
		bool needInit;
		uint nextState;
};
#endif // BASESTATE_H_INCLUDED
