#include "Colour.h"

void Colour::setColour(uint r,uint g, uint b, uint a)
{
   red = r;
   green = g;
   blue = b;
   alpha = a;
}

void Colour::setColour(uint r, uint g, uint b)
{
   setColour(r,g,b,255);
}

void Colour::setColour(uint c)
{
   if(c == RED)
	{
		this->red = 255;
		this->green = 0;
		this->blue = 0;
	}
	else if(c == GREEN)
	{
		this->red = 0;
		this->green = 255;
		this->blue = 0;
	}
	else if(c == BLUE)
	{
		this->red = 0;
		this->green = 0;
		this->blue = 255;
	}
	else if(c == YELLOW)
	{
		this->red = 255;
		this->green = 255;
		this->blue = 0;
	}
	else if(c == WHITE)
	{
		this->red = 255;
		this->green = 255;
		this->blue = 255;
	}
	else if(c == BLACK)
	{
		this->red = 0;
		this->green = 0;
		this->blue = 0;
	}
	else if(c == PURPLE)
	{
		this->red = 128;
		this->green = 0;
		this->blue = 128;
	}
	else if(c == MAGENTA)
	{
		this->red = 255;
		this->green = 0;
		this->blue = 255;
	}
	else if(c == ORANGE)
	{
		this->red = 255;
		this->green = 128;
		this->blue = 0;
	}
	else if (c == BROWN)
	{
		this->red = 128;
		this->green = 64;
		this->blue = 0;
	}
	this->alpha = 255;
}

void inline Colour::setColour(Colour c)
{
   setColour(c.red,c.green,c.blue,c.alpha);
}

inline bool Colour::isEqual(uint r, uint g, uint b, uint a)
{
   if(red != r)
      return false;
   if(green != g)
      return false;
   if(blue != b)
      return false;
   if(alpha != a)
      return false;

   return true;
}

inline bool Colour::isEqual(uint r, uint g, uint b)
{
   return isEqual(r,g,b,255);
}

inline bool Colour::isEqual(Colour c)
{
   return isEqual(c.red,c.green,c.blue,c.alpha);
}

inline bool Colour::isEqual(uint colour)
{
   Colour temp(colour);
   return isEqual(temp);
}

SDL_Color Colour::getColour()
{
	SDL_Color tempCol;
	tempCol.r = red;
	tempCol.g = green;
	tempCol.b = blue;
	return tempCol;
}

