#ifndef COLOUR_H_INCLUDED
#define COLOUR_H_INCLUDED

#include "Types.h"
#include <SDL/SDL.h>
// TODO: potentially useful operations for colours...

enum colours
{
	RED,
	GREEN,
	BLUE,
	WHITE,
	BLACK,
	YELLOW,
	PURPLE,
	MAGENTA,
	ORANGE,
	BROWN
};

class Colour
{
   public:
      Colour(uint r,uint g,uint b)              //	Create a colour object using RGB
      {
         setColour(r,g,b);
      }
      Colour(uint r, uint g, uint b, uint a)	   //	RGBA colour
      {
         setColour(r,g,b,a);
      }
      Colour(uint colour)								//	Create a colour object using predefines
      {
         setColour(colour);
      }
      Colour(const Colour& colour)                     // Create a colour using another colour
      {
			red = colour.red;
			green = colour.green;
			blue = colour.blue;
			alpha = colour.alpha;
      }
      Colour()												//	Create a default colour object (WHITE)
      {
         setColour(WHITE);
      }

      void setColour(uint r,uint g,uint b);           // Set the colour using RGB
      void setColour(uint r, uint g, uint b, uint a);	//	Set the colour using RGBA
      void setColour(uint colour);							//	Set the colour using predefines
      void setColour(Colour colour);                  // Set the colour using another colour

		SDL_Color getColour();		//	Converts the stored colour to an SDL_Color object


      // Operators
      // Equivalency
      bool operator==(Colour colour){return isEqual(colour);};
      bool operator==(uint colour){return isEqual(colour);};
      bool isEqual(uint r, uint g, uint b);
      bool isEqual(uint r, uint g, uint b, uint a);

      // Colour data
      uint red;
      uint green;
      uint blue;
      uint alpha;

   private:
      bool isEqual(uint colour);
      bool isEqual(Colour colour);
};

#endif // COLOUR_H_INCLUDED
