#ifndef INPUTHANDLER_H_INCLUDED
#define INPUTHANDLER_H_INCLUDED
// Adapted code from Miq01

#include <SDL/SDL.h>

#include "KeyboardDefines.h"	//	Defs for keyboard mapping

class InputHandler
{
   public:
      InputHandler();
      ~InputHandler();

      void Update();					//	Get current status of keyboard
      #ifdef PLATFORM_GP2X
         void KeyDown(const Uint8& key);
         void KeyUp(const Uint8& key);
      #endif
      #ifdef PLATFORM_PC
         void KeyDown(const SDLKey& key);
         void KeyUp(const SDLKey& key);
      #endif

      bool IsStart()
      {
         return mKStart;
      }
      bool IsSelect()
      {
         return mKSelect;
      }
      bool IsClick()
      {
         return mKClick;
      }
      bool IsUp()
      {
         return mKUp;
      }
      bool IsDown()
      {
         return mKDown;
      }
      bool IsLeft()
      {
         return mKLeft;
      }
      bool IsRight()
      {
         return mKRight;
      }
      bool IsUpLeft()
      {
         return mKUpLeft;
      }
      bool IsUpRight()
      {
         return mKUpRight;
      }
      bool IsDownLeft()
      {
         return mKDownLeft;
      }
      bool IsDownRight()
      {
         return mKDownRight;
      }
      bool IsA()
      {
         return mKA;
      }
      bool IsB()
      {
         return mKB;
      }
      bool IsX()
      {
         return mKX;
      }
      bool IsY()
      {
         return mKY;
      }
      bool IsL()
      {
         return mKL;
      }
      bool IsR()
      {
         return mKR;
      }
      bool IsVolumeUp()
      {
         return mKVolumeUp;
      }
      bool IsVolumeDown()
      {
         return mKVolumeDown;
      }

      void ResetKeys();

   private:
      SDL_Joystick *joy;		//	SDL joystick
      SDL_Event mEvent;
      bool mKStart, mKSelect, mKUp, mKDown, mKLeft, mKRight, mKUpLeft, mKUpRight, mKDownLeft, mKDownRight, mKA, mKB, mKX, mKY, mKL, mKR, mKVolumeUp, mKVolumeDown, mKClick;
};
#endif // INPUTHANDLER_H_INCLUDED
