#ifndef INTVECTOR2D_H_INCLUDED
#define INTVECTOR2D_H_INCLUDED

// TODO: Add fixed point operators once tested.

#include <math.h>
#include <cmath>
#include "Types.h"

class IntVector2d
{
   public:
      IntVector2d();             // Default vector
      IntVector2d(int x,int y);  // Create a vector at this x and y

      void setXY(int x, int y)
      {
         setX(x);
         setY(y);
      }
      void setX(int x)
      {
         this->x = x;
      }
      void setY(int y)
      {
         this-> y = y;
      }
      int getX()
      {
         return x;
      }
      int getY()
      {
         return y;
      }
      // OPERATORS
      bool operator==(IntVector2d& vector);   //   Check if two vectors are equal
      IntVector2d operator- ();               //   Perform negation if vector
      const IntVector2d& operator= ( const IntVector2d& vector );    // Assign value
      const IntVector2d& operator+= ( const IntVector2d& v );
      const IntVector2d& operator-= ( const IntVector2d& v );
      const IntVector2d& operator*= ( const int& s );
      const IntVector2d& operator/= ( const int& s );
      const IntVector2d operator+ ( const IntVector2d& v ) const;
      const IntVector2d operator- ( const IntVector2d& v ) const;
      const IntVector2d operator* ( const int& s ) const;
      const IntVector2d operator/ (int s) const;
      const int dot( const IntVector2d& v ) const;
      const uint length() const;
      const uint lengthSquared() const;
      const IntVector2d unit() const;
      void normalise();

      friend const IntVector2d operator* ( const int& s, const IntVector2d& v )
      {
         return v*s;
      }

      //IntVector2d normcrossprod(IntVector2d v);
      //IntVector2d crossprod(IntVector2d v);

      int* getVector();

   private:
      int x;
      int y;
};

#endif // INTVECTOR2D_H_INCLUDED
