#ifndef KEYBOARDDEFINES_H_INCLUDED
#define KEYBOARDDEFINES_H_INCLUDED

#include <SDL/SDL.h>

	//	The below defines correspond to the buttons on the GP2X
#ifdef PLATFORM_GP2X
	/* GP2X button mapping */
enum MAP_KEY
{
	GP2X_UP         , // 0
	GP2X_UPLEFT    , // 1
	GP2X_LEFT       , // 2
	GP2X_DOWNLEFT  , // 3
	GP2X_DOWN       , // 4
	GP2X_DOWNRIGHT , // 5
	GP2X_RIGHT      , // 6
	GP2X_UPRIGHT   , // 7
	GP2X_START      , // 8
	GP2X_SELECT     , // 9
	GP2X_L         , // 10
	GP2X_R         , // 11
	GP2X_A         , // 12
	GP2X_B         , // 13
	GP2X_Y         , // 14
	GP2X_X         , // 15
	GP2X_VOLUP     , // 16
	GP2X_VOLDOWN   , // 17
	GP2X_CLICK       // 18
};
#endif

#ifdef PLATFORM_PC
	#define GP2X_START           (SDLK_RETURN)
	#define GP2X_SELECT          (SDLK_RSHIFT)
	#define GP2X_UP              (SDLK_UP)
	#define GP2X_DOWN            (SDLK_DOWN)
	#define GP2X_LEFT            (SDLK_LEFT)
	#define GP2X_RIGHT           (SDLK_RIGHT)
	#define GP2X_UPLEFT          (SDLK_KP7)
	#define GP2X_UPRIGHT         (SDLK_KP9)
	#define GP2X_DOWNLEFT        (SDLK_KP3)
	#define GP2X_DOWNRIGHT       (SDLK_KP1)
	#define GP2X_CLICK           (SDLK_SPACE)
	#define GP2X_A               (SDLK_z)
	#define GP2X_B               (SDLK_x)
	#define GP2X_X               (SDLK_a)
	#define GP2X_Y               (SDLK_s)
	#define GP2X_L               (SDLK_q)
	#define GP2X_R               (SDLK_w)
	#define GP2X_VOLUP           (SDLK_v)
	#define GP2X_VOLDOWN         (SDLK_b)
#endif


#endif // KEYBOARDDEFINES_H_INCLUDED
