#ifndef MUSIC_H
#define MUSIC_H



#include <SDL/SDL.h>
#include <SDL/SDL_mixer.h>
#include <string>
#include "Types.h"
#ifdef MEMWATCH
#include "Memwatch.h"
#endif
using namespace std;

class Music
{
public:
	Music();
	~Music();

	void init();

	bool loadMusic(string musicFile);

	bool isPlaying();
	bool isPaused();

	void play();
	void pause();
	void stop();
	void fade(uint ms);

	void setLooping(bool looping);
	void setLooping(uint numLoops);

	void setVolume(uint volume);
	uint getVolume()
	{
	    return Mix_VolumeMusic(-1);
	}
	void shutdown();
	void freeAll();
private:
	Mix_Music *music;
	int numLoops;
};
#endif	//	MUSIC_H
