#include "MyGame.h"

MyGame::MyGame(string appName, uint xRes, uint yRes, uint fps)
{
    this->appName = appName;
    this->xRes = xRes;
    this->yRes = yRes;
    gameTimer.setMode(fps);
    this->isPaused = false;
}

MyGame::~MyGame()
{
}


void MyGame::init()
{
    #ifdef PLATFORM_GP2X
        this->loadMenu = false;
    #endif
		  state = NULL;
		  state = new BaseState;

    if(SDL_Init(SDL_INIT_JOYSTICK | SDL_INIT_VIDEO | SDL_INIT_AUDIO | SDL_INIT_TIMER) < 0)			// Initialise SDL
	{
        fprintf (stderr, "Couldn't initialize SDL: %s\n", SDL_GetError ());
		exit (1);
	}

	/* Set xRes x yRes 16-bits video mode */
	screen = SDL_SetVideoMode (xRes, yRes, 16, SDL_SWSURFACE);
	if (screen == NULL)
	{
		fprintf (stderr, "Couldn't set %d x %d x 16 video mode: %s\n",xRes, yRes, SDL_GetError ());
		exit (2);
	}

    #ifdef PLATFORM_PC
        //  If we are not on the GP2X, we can display a window title.
        SDL_WM_SetCaption(this->appName.c_str(), 0);
    #endif

   SDL_ShowCursor(SDL_DISABLE);															// Disable mouse cursor on gp2x

   // Setup timer now
	gameTimer.setLimit(1);	//	Set the specified fps for physics updates
	gameTimer.storeTime();

	state->setNextState(STATE_TITLE);
#ifdef PLATFORM_PC
	Mix_OpenAudio(MIX_DEFAULT_FREQUENCY, AUDIO_S16, MIX_DEFAULT_CHANNELS, 4096);		// Initialize SDL_mixer for PC, buffer is set higher
#endif
#ifdef PLATFORM_GP2X
	MMUHack hack;
   hack.initHack();
	Mix_OpenAudio(MIX_DEFAULT_FREQUENCY, AUDIO_S16, MIX_DEFAULT_CHANNELS, 128);			// Initialize SDL_mixer for GP2X, buffer is set lower than PC
#endif
	TTF_Init();				//	Startup font library
}

void MyGame::stateManagement()
{
	//	Check if the state itself wants to change states
	uint next = state->getNextState();

	if(state)
	{
		delete state;
		state = NULL;
	}

   if(next == STATE_TITLE)
	{
      state = new StateTitle;
	}
}
