#ifndef PARSER_H
#define PARSER_H

#include <string>
#include <iostream>
#include <fstream>
#include <queue>

#include "Command.h"
#include "TextDoc.h"
#include "Types.h"
#include "StringUtility.h"

using namespace std;

class Parser : public TextDoc
{
public:
	Parser(){};
	~Parser(){};

	bool createCommandList(string fileName);		//	Load a script file, parses it and creates a commandlist

	Command getNextCommand();	//	Gets the next command from the commandlist



	string getExtensionlessFilename(string name);	//	gets a filename minus the extension
	string stripParentDirectory(string name);		//	removes the parent directory and just leaves the filename
	string getParentDirectory(string fileName);		//	Strips the filename and only leaves the path to the parent folder
	string getValue(string variable);		//	Get a single value with the specified variable name.
	string stripValue(string variable);						//	Rmoves the latest value from the string

	// string* getValues(string variable);		//	Get multiple values with the specified variable name.

	string getVariableName(string line);	//	Extracts the name of a variable from a raw string
	string stripVariableName(string line);	//	Removes the variable name from a string and leaves the values only.

    uint getNumCommands()
    {
        return commandList.size();
    }
private:
	queue <Command> commandList;	//	stores all decoded commands
	StringUtility util;             //  Helper object to perform string conversions.
};

#endif	//	PARSER_H
