#include "Random.h"

Random::Random(int min, int max)
{
	setLimits(min,max);
	randSeed();
}

Random::Random()
{
	setLimits(0,1);
	randSeed();
}

Random::~Random()
{
}

bool Random::nextBool()
{
if(rand()%2)
	return true;

return false;
}

float Random::nextFloat()
{
	float range = (float)max - (float)min;
	return (min + float(range * rand() / (RAND_MAX + 1.0f )));
}

double Random::nextDouble()
{
	double range = (double)max - (double)min;
	return (min + double(range * rand() / (RAND_MAX + 1.0)));
}

int Random::nextInt()
{
	return (min + rand() % (max - min +1));
}

void Random::setSeed(int seed)
{
	srand(seed);
}

void Random::setLimits(int min, int max)
{
	setMin(min);
	setMax(max);
}

void Random::setMax(int max)
{
	this->max = max;
}

void Random::setMin(int min)
{
	this->min = min;
}
