#ifndef SOUND_H
#define SOUND_H



#include <SDL/SDL.h>
#include <SDL/SDL_mixer.h>
#include <string>
#include "Types.h"
#ifdef MEMWATCH
#include "Memwatch.h"
#endif
using namespace std;

class Sound
{
public:
	Sound();
	~Sound();

	void init();

	bool loadSound(string soundName);
	void setLoops(int loops)
	{
		this->loops = loops;
	}

	void setVolume(uint volume)
	{
		Mix_Volume(channel,volume);
	}
	uint getVolume()
	{
	    return Mix_Volume(channel,-1);
	}

	bool isPlaying();
	bool isPaused();

	void play();
	void pause();
	void stop();

	void shutdown();
	void freeAll();
private:
	Mix_Chunk *sound;
	int channel;
	int loops;
};
#endif	//	SOUND_H
