#include "Sprite.h"

Sprite::Sprite()
{
   setX(0);
   setY(0);
}

Sprite::Sprite(int x, int y)
{
   setX(x);
   setY(y);
}

bool Sprite::setSpriteImage(string fileName)
{
   return image.loadImage(fileName);
}

void Sprite::render(SDL_Surface* screen)
{
   image.renderImage(screen,getX(),getY());
}

bool Sprite::hasCollided(Sprite &spr)
{
   uint a = image.getWidth()/2;
   uint b = spr.image.getWidth()/2;

   IntVector2d temp = *this - IntVector2d(spr.getX(),spr.getY());

	if (temp.lengthSquared() <= a * a + b * b)
	 	return true;

	return false;
}
