#ifndef SPRITE_H_INCLUDED
#define SPRITE_H_INCLUDED

#include "Image.h"
#include "IntVector2d.h"

class Sprite : public IntVector2d
{
public:
   Sprite();
   Sprite(int x,int y);

   bool setSpriteImage(string fileName);     // Loads an image for this sprite

   void setAlpha(uint alpha)
   {
      image.setAlpha(alpha);
   }
   uint getAlpha()
   {
       return image.getAlpha();
   }
   void render(SDL_Surface* screen);         // Draws the image onto the screen

   bool hasCollided(Sprite &spr);			//	Has this sprite collided with the passed in sprite?

   uint getImageWidth()
   {
      return image.getWidth();
   }
   uint getImageHeight()
   {
      return image.getHeight();
   }
	void setUseHardware(bool useHW)
	{
		image.setUseHardware(useHW);
	}
	void setUseRotoZoom(bool useRZ)
	{
		image.setUseRotoZoom(useRZ);
	}
	void setZoom(float zoom)
	{
		image.setZoom(zoom);
	}
	void setScaleX(float scaleX)
	{
		image.setScaleX(scaleX);
	}
	void setScaleY(float scaleY)
	{
		image.setScaleY(scaleY);
	}
	void setRotation(float angle)
	{
		image.setRotation(angle);
	}
	void clear()
	{
		image.clear();
	}
private:
   Image image;
};


#endif // SPRITE_H_INCLUDED
