#ifndef STATEMANAGER_H_INCLUDED
#define STATEMANAGER_H_INCLUDED

#include "Types.h"      //  Just some shorthands
#include "States.h"     //  The StateManager needs to know the states available. Configure here.

/*
You should only modify the list of states in states.h. Modifying anything else may cause you problems unless you know what you are doing!

This is a state manager class, it handles the logic of changing game states. actual state creation goes in your overided engine class.
*/

class StateManager
{
public:
	StateManager()
	{
	    state = STATE_TITLE;
	    needInit = true;
    }
   ~StateManager() {}

	void setGameState(uint state) 	//	Set the engine to run in a specific mode
	{
	    this->state = state;
	    needInit = true;
	}
	uint getGameState()				//	Gets the current mode that the engine is running in
	{
	    return state;
	}
	void nullifyState()                 //	Sets the state to NULL (You do this to end the game.)
	{
	    state = STATE_NULL;
	    needInit = false;
    }

	void setNeedInit(bool needInit) //	Sets the status of whether the state init function needs calling
	{
	    this->needInit = needInit;
	}
	bool getNeedInit()  				//	gets the status of whether the state init function needs calling
    {
        return needInit;
    }
private:
	uint state;			         //	Store the current state
	bool needInit;		            //	Store if the the state needs to perorm the init loop.
};
#endif // STATEMANAGER_H_INCLUDED
