#ifndef STATETITLE_H_INCLUDED
#define STATETITLE_H_INCLUDED

#include "States.h"     // Make sure your state is listed in this include.
/*
Title screen state to show title screen demo
This can be considered as an example of how to create a new state
*/

#include "Parser.h"             //  Parses the sound set files
#include "VectorInVector.h"
#include "Background.h"
#include "Sprite.h"
#include "Music.h"
#include "Sound.h"
#include "TextHandler.h"

#ifdef PLATFORM_GP2X
#include "MMUHack.h"
#endif

class StateTitle : public BaseState
{
   public:
      StateTitle();
      virtual void init();
      virtual void clear();
      virtual void render(SDL_Surface *screen);
      virtual void update();
      virtual void keyboard();
      virtual ~StateTitle();
	private:
        void parseSoundList();
        void loadSoundSet(string fileName);

        TextHandler text;
		Background backImage;
        vector <bool> hasMusic;
		vector <Music> music;               //  [SET].play():
		vector <string> names;
		vector <string> songNames;
		VectorInVector <bool> hasSound;     //  [SET][SOUND]   = true/false
		VectorInVector <Sound> soundSets;   //  [SET][SOUND].play();
		VectorInVector <string> soundNames;

		uint setNum;
        uint maxSets;
#ifdef PLATFORM_GP2X
		MMUHack hack;
#endif
};

#endif // STATETITLE_H_INCLUDED
