#ifndef STRINGUTILITY_H
#define STRINGUTILITY_H

#include "Types.h"
#include <string>
#include <sstream>
using namespace std;

class StringUtility
{
public:
	StringUtility();
	~StringUtility();

	//	OS Format conversion
	//	Note that these only work if the TO target is the same as the host OS as the app is run on!
	string linToWin(string line);
	string winToLin(string line);
	string macToWin(string line);
	string winToMac(string line);
	string macToLin(string line);
	string linToMac(string line);
	//	Various to string conversions
	string floatToString(float value);
	string doubleToString(double value);
	string longToString(long value);
	string intToString(int value);
	string shortToString(short value);

	//	String to various conversions
	float stringToFloat(string value);
	double stringToDouble(string value);
	long stringToLong(string value);
	int stringToInt(string value);
	short stringToShort(string value);

	//	Case modifyers
	char upper(char l);	//	converts character to uppercase
	char lower(char l);	//	converts character to lowercase

	//	Digit/Letter checking
	bool isLetter(char letter);
	bool isDigit(char digit);

	//	Type modifyers
	int charToInt(char value);
	char intToChar(int value);

	//  Formatting
	string leadingZero(int value)      //  prepends a 0 if necessary
	{
        return (value<10?"0":"") + intToString(value);
	}
private:

};
#endif	//	STRINGUTILITY_H
