#ifndef TEXTDOC_H
#define TEXTDOC_H

#include <fstream>
#include <string>
#include <vector>
#include <iostream>
#include "StringUtility.h"
#ifdef MEMWATCH
#include "Memwatch.h"
#endif
using namespace std;

class TextDoc
{
public:
	TextDoc();
	~TextDoc();
	int size();
	void load(string file);					//	Load a plain text file
	void save(string file);					//	Save a plain text file
	void search(string target);				//	Search for a string in the doc
	void editLine(int line, string newData);//	replace a line of data with new data
	string getLine(int line);				//	get the string data of the line
	void viewDoc();							//	View an outline of the doc
	void clear();							//	Clear data out of doc.
	void append(string data);				//	add s string to the document
private:
	int findLine(string target);
	int findChar(string target, int line);

	vector <string>docData;
};

#endif	//	TEXTDOC_H
