#ifndef VECTORINVECTOR_H
#define VECTORINVECTOR_H

/*
vector in a vector
class based on code examples here: http://www.tek-tips.com/faq.cfm?pid=116
Modifications by Kevin Winfield-Pantoja
*/

#include <vector>
using namespace std;
#include "Types.h"


template <typename T>
class VectorInVector
{
public:
    VectorInVector()
	{};

    VectorInVector(uint rows, uint cols)	//	Create a vectorInVector with specified dimensions.
		:data(rows, vector<T>(cols))
	{}

   vector<T> & operator[](uint i)
	{
		return data[i];
	}

   const vector<T> & operator[] (uint i) const
	{
		return data[i];
	}

	void resize(uint rows, uint cols)		//	Change the vectorInVector dimensions
	{
        data.resize(rows);
        for(uint i = 0;i < rows;i++) data[i].resize(cols);
    }

	void clear()					//	Clears all the vectorInVector contents
	{
		//	clear all sub entries
		for (uint i = 0; i < data.size(); i++)
		{
			data[i].clear();
		}
		//	clear top level
		data.clear();
	}

	uint size()					//	Return the number of vectors stored from the top level.
	{
		return data.size();
	}

	uint size(uint index)			//	Return the number of data elements stored in a specific vector
	{
		uint mySize = 0;

		//	Check if the index value is valid
		if (index >= 0 && index < data.size())
		{
			mySize = data[index].size();
		}
		return mySize;
	}
private:
    vector<vector<T> > data;
};

#endif //	VECTORINVECTOR_H
